using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Text;
using System.IO;
using System.Runtime.Remoting;

namespace WordPad
{
    public partial class Wordpad : Form
    {
        InstalledFontCollection Fonts = new InstalledFontCollection();
        string filename = "Document";
        string address = string.Empty;
        int flagsave,flagUndeline,flagBold,flagItalic;
        public string fontname
        {
            get
            {
                return cbxFont.SelectedItem.ToString();
            }
            set
            {
                cbxFont.SelectedItem = value;
            }
        }
        public float fontsize
        {
            get
            {
                return Convert.ToInt32(cbxFontSize.SelectedItem);
            }
            set
            {
                cbxFontSize.SelectedItem = value;
            }
        }
        public string StatusText
        {
            get
            {
                return StatusLabel.Text;
            }
            set
            {
                StatusLabel.Text = value;
            }
        }
        public Wordpad()
        {
            InitializeComponent();
            fontsize = 10;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.Text = filename + " - WordPad";
            foreach (FontFamily f in Fonts.Families)
                cbxFont.Items.Add(f.Name);
            cbxFont.SelectedItem = "Arial";
            cbxFontSize.SelectedItem = "10";
            cbxFontScript.SelectedItem = "Western";
            btnAlignLeft.BackColor = Color.LightBlue;
            IDataObject idata = Clipboard.GetDataObject();
            if (idata.GetDataPresent(DataFormats.Text))
            {
                btnPaste.Enabled = true;
                toolPaste.Enabled = true;
            }
            else
            {
                btnPaste.Enabled = false;
                toolPaste.Enabled = false;
            }
        }
        private void toolNew_Click(object sender, EventArgs e)
        {
            if (flagsave == 1)
            {
                DialogResult result = MessageBox.Show("Save changes to Document?", "WordPad",
                MessageBoxButtons.YesNoCancel, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1);
                switch (result)
                {
                    case DialogResult.Yes:
                        saveFileDialog1.FileName = address;
                        if (filename == "Document")
                        {
                            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                            {
                                address = saveFileDialog1.FileName;
                                richtxt.SaveFile(address);
                                richtxt.Clear();
                                btnCopy.Enabled = false;
                                btnCut.Enabled = false;
                                toolCopy.Enabled = false;
                                toolCut.Enabled = false;
                                StatusText = "New document created";
                                filename = "Document";
                            }
                        }
                        else
                        {
                            address = saveFileDialog1.FileName;
                            richtxt.SaveFile(address);
                            richtxt.Clear();
                            btnCopy.Enabled = false;
                            btnCut.Enabled = false;
                            toolCopy.Enabled = false;
                            toolCut.Enabled = false;
                            StatusText = "New document created";
                            filename = "Document";
                        }
                        break;
                    case DialogResult.No:
                        richtxt.Clear();
                        btnCopy.Enabled = false;
                        btnCut.Enabled = false;
                        toolCopy.Enabled = false;
                        toolCut.Enabled = false;
                        StatusText = "New document created";
                        filename = "Document";
                        break;

                }
            }
            else
            {
                richtxt.Clear();
                btnCopy.Enabled = false;
                btnCut.Enabled = false;
                toolCopy.Enabled = false;
                toolCut.Enabled = false;
                StatusText = "New document created";
                filename = "Document";
            }
            flagsave = 0;
            Text = filename + " - WordPad";
        }

        private void toolOpen_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                richtxt.LoadFile(openFileDialog1.FileName);
                address = openFileDialog1.FileName;
                string s = address;
                s = s.Split('.')[0];
                s = s.Split('\\')[(s.Split('\\').Length) - 1];
                filename = s;
                this.Text = filename + " - WordPad";
                StatusText = "An existing document opened";
                flagsave = 0;
            }

        }
        private void toolSaveas_Click(object sender, EventArgs e)
        {
            saveFileDialog1.FileName = address;
            saveFileDialog1.ShowDialog();
            address = saveFileDialog1.FileName;
            string s = address;
            s = s.Split('.')[0];
            s = s.Split('\\')[(s.Split('\\').Length) - 1];
            filename = s;
            this.Text = filename + " - WordPad";
            richtxt.SaveFile(address);
            StatusText = "document saved";
            flagsave = 0;
        }
        private void toolSave_Click(object sender, EventArgs e)
        {
            saveFileDialog1.FileName = address;
            if (filename == "Document")
                saveFileDialog1.ShowDialog();
            address = saveFileDialog1.FileName;
            string s = address;
            s = s.Split('.')[0];
            s = s.Split('\\')[(s.Split('\\').Length) - 1];
            filename = s;
            this.Text = filename + " - WordPad";
            richtxt.SaveFile(address);
            StatusText = "document saved";
            flagsave = 0;

        }

        private void toolToolbar_Click(object sender, EventArgs e)
        {
            if (toolToolbar.Checked == true)
            {
                toolToolbar.Checked = false;
                toolbar.Visible = false;
            }
            else
            {
                toolToolbar.Checked = true;
                toolbar.Visible = true;
            }
        }

        private void toolFormatbar_Click(object sender, EventArgs e)
        {
            if (toolFormatbar.Checked == true)
            {
                toolFormatbar.Checked = false;
                Formatbar.Visible = false;
            }
            else
            {
                toolFormatbar.Checked = true;
                Formatbar.Visible = true;
            }
        }

        private void toolStausbar_Click(object sender, EventArgs e)
        {
            if (toolStausbar.Checked == true)
            {
                toolStausbar.Checked = false;
                statusbar.Visible = false;
            }
            else
            {
                toolStausbar.Checked = true;
                statusbar.Visible = true;
            }
        }
        private void richtxt_TextChanged(object sender, EventArgs e)
        {
            flagsave = 1;
            btnUndo.Enabled = true;
            toolUndo.Enabled = true;
            StatusText = "Ready";
        }

        private void btnNew_Click(object sender, EventArgs e)
        {
            toolNew_Click(sender, e);
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            toolOpen_Click(sender, e);
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            toolSave_Click(sender, e);
        }

        private void btnAbout_Click(object sender, EventArgs e)
        {
            toolAbout_Click(sender, e);
        }

        private void btnUndo_Click(object sender, EventArgs e)
        {
            toolUndo_Click(sender, e);
            StatusText = "Reverses the last action";
        }

        private void toolUndo_Click(object sender, EventArgs e)
        {
            richtxt.Undo();
        }

        private void toolAbout_Click(object sender, EventArgs e)
        {
           
            MessageBox.Show("Wordpad ver 1.0\nDesign By : Mehdi Sajedifar\nEmail : m3hdi_ii@yahoo.com", "CopyRight",
                            MessageBoxButtons.OK,
                            MessageBoxIcon.Information,
                            MessageBoxDefaultButton.Button1);
        }

        private void toolColor_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                Color c = colorDialog1.Color;
                richtxt.SelectionColor = c;
                StatusText = "Font Color change to " + c.Name;
            }
        }

        private void btnColor_Click(object sender, EventArgs e)
        {
            toolColor_Click(sender, e);
        }

        private void btnAlignLeft_Click(object sender, EventArgs e)
        {

            btnCenter.BackColor = DefaultBackColor;
            btnAlignRight.BackColor = DefaultBackColor;
            btnAlignLeft.BackColor = Color.LightBlue;
            richtxt.SelectionAlignment = HorizontalAlignment.Left;
        }

        private void btnAlignRight_Click(object sender, EventArgs e)
        {
            btnAlignLeft.BackColor = DefaultBackColor;
            btnCenter.BackColor = DefaultBackColor;
            richtxt.SelectionAlignment = HorizontalAlignment.Right;
            btnAlignRight.BackColor = Color.LightBlue;
        }

        private void btnCenter_Click(object sender, EventArgs e)
        {
            btnAlignRight.BackColor = DefaultBackColor;
            btnAlignLeft.BackColor = DefaultBackColor;
            richtxt.SelectionAlignment = HorizontalAlignment.Center;
            btnCenter.BackColor = Color.LightBlue;
        }
        private void btnBullets_Click(object sender, EventArgs e)
        {
            if (btnBullets.BackColor == DefaultBackColor)
            {
                btnBullets.BackColor = Color.LightBlue;
                richtxt.BulletIndent = 30;
                richtxt.SelectionBullet = true;
            }
            else
            {
                btnBullets.BackColor = DefaultBackColor;
                richtxt.SelectionBullet = false;
            }
        }
        private void btnUnderline_Click(object sender, EventArgs e)
        {

            if (btnUnderline.BackColor == DefaultBackColor)
            {
                flagUndeline = 1;
                btnUnderline.BackColor = Color.LightBlue;
                if (flagBold==1 && flagItalic==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline | FontStyle.Bold | FontStyle.Italic);
                else if (flagBold==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline | FontStyle.Bold);
                else if (flagItalic==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline | FontStyle.Italic);
                else
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline);
                
                
                
            }
            else
            {
                flagUndeline = 0;
                btnUnderline.BackColor = DefaultBackColor;
                if (flagBold==1 && flagItalic==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Bold | FontStyle.Italic);
                else if (flagBold==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Bold);
                else if (flagItalic==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Italic);
                else
                    richtxt.SelectionFont = new Font(fontname, fontsize);
            }
        }

        private void btnItlic_Click(object sender, EventArgs e)
        {
            if (btnItlic.BackColor == DefaultBackColor)
            {
                flagItalic = 1;
                btnItlic.BackColor = Color.LightBlue;
                if (flagBold==1 && flagUndeline==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline | FontStyle.Bold | FontStyle.Italic);
                else if (flagBold==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Italic | FontStyle.Bold);
                else if (flagUndeline==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline | FontStyle.Italic);
                else
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Italic);
            }
            else
            {
                flagItalic = 0;
                btnItlic.BackColor = DefaultBackColor;
                if (flagBold==1 && flagUndeline==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline | FontStyle.Bold);
                else if (flagBold==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Bold);
                else if (flagUndeline==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline);
                else
                    richtxt.SelectionFont = new Font(fontname, fontsize);

            }
        }
        private void btnBold_Click(object sender, EventArgs e)
        {
            if (btnBold.BackColor == DefaultBackColor)
            {
                flagBold = 1;
                btnBold.BackColor = Color.LightBlue;
                if (flagUndeline==1 && flagItalic==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline | FontStyle.Bold | FontStyle.Italic);
                else if (flagUndeline==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline | FontStyle.Bold);
                else if (flagItalic==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Bold | FontStyle.Italic);
                else
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Bold);
            }
            else
            {
                flagBold = 0;
                btnBold.BackColor = DefaultBackColor;
                if (flagUndeline==1 && flagItalic==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline | FontStyle.Italic);
                else if (flagUndeline==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline);
                else if (flagItalic==1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Italic);
                else
                    richtxt.SelectionFont = new Font(fontname, fontsize);
            }
        }
        private void Wordpad_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (flagsave == 1)
            {
                DialogResult result = MessageBox.Show("Save changes to Document?", "WordPad",
                MessageBoxButtons.YesNoCancel, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1);
                switch (result)
                {
                    case DialogResult.Yes:
                        saveFileDialog1.FileName = address;
                        if (filename == "Document")
                        {
                            if (saveFileDialog1.ShowDialog() == DialogResult.Cancel)
                            {
                                e.Cancel = true;
                            }
                        }
                        address = saveFileDialog1.FileName;
                        richtxt.SaveFile(address);
                        break;
                    case DialogResult.Cancel:
                        e.Cancel = true;
                        break;

                }
            }
        }
        private void toolExit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btnTime_Click(object sender, EventArgs e)
        {
            Date D = new Date();
            D.ShowDialog();
            richtxt.AppendText(D.insert);
        }

        private void cbxFont_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                if (flagBold == 1 && flagItalic == 1 && flagUndeline == 1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Bold | FontStyle.Italic | FontStyle.Underline);
                else if (flagBold == 1 && flagItalic == 1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Bold | FontStyle.Italic);
                else if (flagBold == 1 && flagUndeline == 1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Bold | FontStyle.Underline);
                else if (flagItalic == 1 && flagUndeline == 1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Italic | FontStyle.Underline);
                else if (flagBold == 1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Bold);
                else if (flagItalic == 1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Italic);
                else if (flagUndeline == 1)
                    richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline);
                else
                    richtxt.SelectionFont = new Font(fontname, fontsize);
                richtxt.Select();

            }
            catch
            {
                fontname="Arial";
                if(fontsize==0)
                    fontsize = 10;
            }
        }
        private void cbxFontSize_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (flagBold == 1 && flagItalic == 1 && flagUndeline == 1)
                richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Bold | FontStyle.Italic | FontStyle.Underline);
            else if (flagBold == 1 && flagItalic == 1)
                richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Bold | FontStyle.Italic);
            else if (flagBold == 1 && flagUndeline == 1)
                richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Bold | FontStyle.Underline);
            else if (flagItalic == 1 && flagUndeline == 1)
                richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Italic | FontStyle.Underline);
            else if (flagBold == 1)
                richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Bold);
            else if (flagItalic == 1)
                richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Italic);
            else if (flagUndeline == 1)
                richtxt.SelectionFont = new Font(fontname, fontsize, FontStyle.Underline);
            else
                richtxt.SelectionFont = new Font(fontname, fontsize);
            richtxt.Select();
        }
        private void cbxFontScript_SelectedIndexChanged(object sender, EventArgs e)
        {
            richtxt.Select();
        }
        private void richtxt_SelectionChanged(object sender, EventArgs e)
        {
            if (richtxt.SelectedText != "")
            {
                btnCopy.Enabled = true;
                toolCopy.Enabled = true;
                btnCut.Enabled = true;
                toolCut.Enabled = true;
            }
            //Clipboard.SetDataObject(textBox1.SelectedText);
            else
            {
                btnCopy.Enabled = false;
                toolCopy.Enabled = false;
                btnCut.Enabled = false;
                toolCut.Enabled = false;
            }
            IDataObject idata = Clipboard.GetDataObject();
            if (idata.GetDataPresent(DataFormats.Text))
            {
                btnPaste.Enabled = true;
                toolPaste.Enabled = true;
            }
            else
            {
                btnPaste.Enabled = false;
                toolPaste.Enabled = false;
            }
        }

        private void btnCut_Click(object sender, EventArgs e)
        {
            //Clipboard.SetDataObject(richtxt.SelectedText);
           richtxt.Cut();
        }

        private void btnCopy_Click(object sender, EventArgs e)
        {
            richtxt.Copy();
            //Clipboard.SetDataObject(richtxt.SelectedText);
        }

        private void btnPaste_Click(object sender, EventArgs e)
        {
            richtxt.Paste();
            //IDataObject iData = Clipboard.GetDataObject();
            //richtxt.AppendText((String)iData.GetData(DataFormats.Text));
        }

        private void toolCut_Click(object sender, EventArgs e)
        {
            btnCut_Click(sender, e);
        }

        private void toolCopy_Click(object sender, EventArgs e)
        {
            btnCopy_Click(sender, e);
        }

        private void toolPaste_Click(object sender, EventArgs e)
        {
            btnPaste_Click(sender, e);
        }

        private void toolBullet_Click(object sender, EventArgs e)
        {
            btnBullets_Click(sender, e);
        }

        private void toolDateTime_Click(object sender, EventArgs e)
        {
            btnTime_Click(sender, e);
        }

        private void toolImage_Click(object sender, EventArgs e)
        {
            if (openFileDialog2.ShowDialog() == DialogResult.OK)
            {
                Bitmap img = new Bitmap(openFileDialog2.FileName);              
                Clipboard.SetDataObject(img);
                richtxt.Paste();
            }
        }

        private void toolFont_Click(object sender, EventArgs e)
        {
            if (fontDialog1.ShowDialog() == DialogResult.OK)
            {
                fontname = fontDialog1.Font.Name;
                float f = fontDialog1.Font.Size;
                if (f < 9) fontsize = 8;
                else if (f < 10) cbxFontSize.SelectedIndex = 1;
                else if (f < 11) cbxFontSize.SelectedIndex = 2;
                else if (f < 12) cbxFontSize.SelectedIndex = 3;
                else if (f < 14) cbxFontSize.SelectedIndex = 4;
                else if (f < 16) cbxFontSize.SelectedIndex = 5;
                else if (f < 18) cbxFontSize.SelectedIndex = 6;
                else if (f < 20) cbxFontSize.SelectedIndex = 7;
                else if (f < 22) cbxFontSize.SelectedIndex = 8;
                else if (f < 24) cbxFontSize.SelectedIndex = 9;
                else if (f < 26) cbxFontSize.SelectedIndex = 10;
                else if (f < 28) cbxFontSize.SelectedIndex = 11;
                else if (f < 36) cbxFontSize.SelectedIndex = 12;
                else if (f < 48) cbxFontSize.SelectedIndex = 13;
                else if (f < 72) cbxFontSize.SelectedIndex = 14;
                else cbxFontSize.SelectedIndex = 15;
                richtxt.SelectionColor = fontDialog1.Color;
                if (fontDialog1.Font.Bold == true)
                {
                    flagBold = 1;
                    btnBold.BackColor = Color.LightBlue;
                }
                else 
                {
                    flagBold = 0;
                    btnBold.BackColor = DefaultBackColor;
                }
                if (fontDialog1.Font.Italic == true)
                {
                    flagItalic = 1;
                    btnItlic.BackColor = Color.LightBlue;
                }
                else 
                {
                    flagItalic = 0;
                    btnItlic.BackColor = DefaultBackColor;
                }
                if (fontDialog1.Font.Underline == true)
                {
                    flagUndeline = 1;
                    btnUnderline.BackColor = Color.LightBlue;
                }
                else
                {
                    flagUndeline = 0;
                    btnUnderline.BackColor = DefaultBackColor;
                }
                richtxt.SelectionFont = new Font(fontname, fontsize, fontDialog1.Font.Style);
               // richtxt.SelectionColor = c;
                StatusText = "Font change to " + fontname;
            }

        }

        private void cbxFont_Click(object sender, EventArgs e)
        {

        }

        private void cbxFontSize_Click(object sender, EventArgs e)
        {

        }              
    }
}